@ECHO OFF
ECHO OFF
COLOR 0F
CLS

SETLOCAL EnableDelayedExpansion

for /F "tokens=1,2 delims=#" %%a in ('"prompt #$H#$E# & echo on & for %%b in (1) do rem"') do (
  set "DEL=%%a"
)

for /f %%. in ('forfiles /m "%~nx0" /c "cmd /c echo 0x07"') do set bell=%%.

REM %1 is hex port number
REM %2 is dec port number
REM %3 is log mode
REM %4 is control mode

:INIT
SET MODE=0
SET INV=0
SET LOG=%3
IF "%3"=="" SET LOG=0
SET CON=%4
IF "%4"=="" SET CON=0
SET BG=0
SET TX=F
SET BG_MODE=0
SET TX_MODE=0
SET EMPHASIS=0
SET INVERSE=0

REM For debug purposes, log is always on
SET LOG=1

SET DATA_DEC=0
SET DATA_HEX=0
SET DATA_ASCII=0


MODE CON COLS=41 LINES=25
TITLE Terminal Emulator  -  Mode %MODE%
COLOR %BG%%TX%
ECHO Emulated port: $%1 [%2] - Mode %MODE%
ECHO ========================================
GOTO LOOP

:LOOP
TITLE Terminal Emulator  -  Mode !MODE!
@IF EXIST TERM_TEMP.BAT GOTO LOAD
GOTO LOOP

:LOAD
CALL TERM_TEMP.BAT 
DEL TERM_TEMP.BAT /Q
IF "!DATA_HEX!"=="" SET DATA_HEX=0000
IF "!DATA_ASCII!"=="" SET DATA_ASCII=.
SET /A DATA_DEC=0x!DATA_HEX!
IF !LOG!==1 ECHO Mode !MODE! $!DATA_HEX! [!DATA_DEC!] :: !DATA_ASCII! >>TERM_LOG.TXT
IF !BG_MODE!==1 IF !TX_MODE!==1 (
	SET BG_MODE=0
	SET TX_MODE=0
)
IF !BG_MODE!==1 (
	SET BG=!DATA_HEX:~3,1!
	SET BG_MODE=0
	GOTO LOOP
)
IF !TX_MODE!==1 (
	SET TX=!DATA_HEX:~3,1!
	SET TX_MODE=0
	GOTO LOOP
)
IF !MODE!==0 CALL :CHARACTER
IF !MODE!==1 CALL :C !BG!!TX! "!DATA_DEC!"
GOTO LOOP

:CHARACTER
IF !DATA_DEC!==0 (
	IF !CON!==1 CALL :C !BG!!TX! "NUL"
	IF !LOG!==1 ECHO NULL >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==1 (
	IF !CON!==1 CALL :C !BG!!TX! "SOH"
	IF !LOG!==1 ECHO HEADING >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==2 (
	IF !CON!==1 CALL :C !BG!!TX! "STX"
	IF !LOG!==1 ECHO TEXT >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==3 (
	IF !CON!==1 CALL :C !BG!!TX! "ETX"
	IF !LOG!==1 ECHO END >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==4 (
	IF !CON!==1 CALL :C !BG!!TX! "EOT"
	IF !LOG!==1 ECHO END >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==5 (
	IF !CON!==1 CALL :C !BG!!TX! "ENQ"
	IF !LOG!==1 ECHO ENQUIRE >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==6 (
	IF !CON!==1 CALL :C !BG!!TX! "ACK"
	IF !LOG!==1 ECHO ACKNOWLEDGE >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==7 (
	IF !CON!==1 CALL :C !BG!!TX! "BEL"
	ECHO !BELL!
	IF !LOG!==1 ECHO BELL >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==8 (
	IF !CON!==1 CALL :C !BG!!TX! "BSP"
	IF !LOG!==1 ECHO BACKSPACE >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==9 (
	CALL :C !BG!!TX! "	"
	IF !LOG!==1 ECHO TAB >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==10 (
	ECHO.
	IF !LOG!==1 ECHO LINE >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==11 (
	ECHO.
	ECHO.
	ECHO.
	ECHO.
	IF !LOG!==1 ECHO VERTICAL TAB>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==12 (
	FOR /L %%G IN (0,1,25) DO (
		ECHO.
	)
	IF !LOG!==1 ECHO FORMFEED >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==13 (
	ECHO.
	IF !LOG!==1 ECHO CR >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==14 (
	IF !CON!==1 CALL :C !BG!!TX! "SO"
	IF !LOG!==1 ECHO S OUT>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==15 (
	IF !CON!==1 CALL :C !BG!!TX! "SI"
	IF !LOG!==1 ECHO S IN>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==16 (
	IF !CON!==1 CALL :C !BG!!TX! "DLE"
	IF !LOG!==1 ECHO ESCAPE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==17 (
	IF !CON!==1 CALL :C !BG!!TX! "DC1"
	IF !LOG!==1 ECHO CONTROL 1>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==18 (
	IF !CON!==1 CALL :C !BG!!TX! "DC2"
	IF !LOG!==1 ECHO CONTROL 2>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==19 (
	IF !CON!==1 CALL :C !BG!!TX! "DC3"
	IF !LOG!==1 ECHO CONTROL 3>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==20 (
	IF !CON!==1 CALL :C !BG!!TX! "DC4"
	IF !LOG!==1 ECHO CONTROL 4>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==21 (
	IF !CON!==1 CALL :C !BG!!TX! "NAK"
	IF !LOG!==1 ECHO NEGATIVE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==22 (
	IF !CON!==1 CALL :C !BG!!TX! "IDL"
	IF !LOG!==1 ECHO IDLE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==23 (
	IF !CON!==1 CALL :C !BG!!TX! "ETB"
	IF !LOG!==1 ECHO BLOCK END>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==24 (
	IF !CON!==1 CALL :C !BG!!TX! "CAN"
	IF !LOG!==1 ECHO CANCEL>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==25 (
	IF !CON!==1 CALL :C !BG!!TX! "EM"
	IF !LOG!==1 ECHO MEDIA END>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==26 (
	IF !CON!==1 CALL :C !BG!!TX! "SUB"
	IF !LOG!==1 ECHO SUBSTITUTE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==27 (
	IF !CON!==1 CALL :C !BG!!TX! "ESC"
	IF !LOG!==1 ECHO ESCAPE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==28 (
	IF !CON!==1 CALL :C !BG!!TX! "FS"
	IF !LOG!==1 ECHO FILE SEPARATE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==29 (
	IF !CON!==1 CALL :C !BG!!TX! "GS"
	IF !LOG!==1 ECHO GROUP SEPARATE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==30 (
	IF !CON!==1 CALL :C !BG!!TX! "RS"
	IF !LOG!==1 ECHO RECORD SEPARATE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==31 (
	IF !CON!==1 CALL :C !BG!!TX! "US"
	IF !LOG!==1 ECHO UNIT SEPARATE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==32 (
	CALL :C !BG!!TX! " "
	IF !LOG!==1 ECHO SPACE >>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==33 (
	CALL :C !BG!!TX! "!!"
	GOTO :EOF
)
IF !DATA_DEC!==37 (
	CALL :C !BG!!TX! "%%"
	GOTO :EOF
)
IF !DATA_DEC!==127 (
	IF !CON!==1 CALL :C !BG!!TX! "DEL"
	IF !LOG!==1 ECHO DELETE>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==250 (
	SET BG_MODE=1
	IF !LOG!==1 ECHO RECEIVING BG COLOR>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==251 (
	SET TX_MODE=1
	IF !LOG!==1 ECHO RECEIVING TX COLOR>>TERM_LOG.TXT
	GOTO :EOF
)
IF !DATA_DEC!==252 (
	IF !LOG!==1 ECHO CLEAR SCREEN>>TERM_LOG.TXT
	CLS
	GOTO :EOF
)
IF !DATA_DEC!==253 (
	IF !LOG!==1 ECHO INVERT TEXT>>TERM_LOG.TXT
	IF %INVERSE%==0 (
		SET INVERSE=1
		SET IV=!BG!
		SET BG=!TX!
		SET TX=!IV!
		GOTO :EOF
	)
	SET INVERSE=0
	SET IV=!BG!
	SET BG=!TX!
	SET TX=!IV!
	GOTO :EOF
)
IF !DATA_DEC!==254 (
	IF !LOG!==1 ECHO RESET>>TERM_LOG.TXT
	SET BG=0
	SET TX=F
	SET INVERSE=0
	SET BG_MODE=0
	SET TX_MODE=0
	COLOR !BG!!TX!
	CLS
	GOTO :EOF
)
IF !DATA_DEC!==255 (
	IF !LOG!==1 ECHO TOGGLE MODE>>TERM_LOG.TXT
	IF !MODE!==0 (
		SET MODE=1
		GOTO :EOF
	)
	SET MODE=0
	GOTO :EOF
)
CALL :C !BG!!TX! "%DATA_ASCII%"
GOTO :EOF

:WRT
ECHO|SET /P=%1
IF !LOG!==1 ECHO|SET /P=%1 >>TERM_LOG.TXT
GOTO :EOF

:C
SetLocal EnableExtensions EnableDelayedExpansion
Subst `: "!Temp!" >Nul &`: &Cd \
SetLocal DisableDelayedExpansion
Echo(|(Pause >Nul &Findstr "^" >`)
Cmd /A /D /C Set /P "=." >>` <Nul
For /F %%# In (
'"Prompt $H &For %%_ In (_) Do Rem"') Do (
Cmd /A /D /C Set /P "=%%# %%#" <Nul >`.1
Copy /Y `.1 /B + `.1 /B + `.1 /B `.3 /B >Nul
Copy /Y `.1 /B + `.1 /B + `.3 /B `.5 /B >Nul
Copy /Y `.1 /B + `.1 /B + `.5 /B `.7 /B >Nul
)
:__Color
Set "Text=%~2"
If Not Defined Text (Set Text=^")
SetLocal EnableDelayedExpansion
For %%_ In ("&" "|" ">" "<"
) Do Set "Text=!Text:%%~_=^%%~_!"
Set /P "LF=" <` &Set "LF=!LF:~0,1!"
For %%# in ("!LF!") Do For %%_ In (
\ / :) Do Set "Text=!Text:%%_=%%~#%%_%%~#!"
For /F delims^=^ eol^= %%# in ("!Text!") Do (
If #==#! EndLocal
If \==%%# (Findstr /A:%~1 . \` Nul
Type `.3) Else If /==%%# (Findstr /A:%~1 . /.\` Nul
Type `.5) Else (Cmd /A /D /C Echo %%#\..\`>`.dat
Findstr /F:`.dat /A:%~1 .
Type `.7))
If "\n"=="%~3" (Shift
Echo()
Shift
Shift
If ""=="%~1" Del ` `.1 `.3 `.5 `.7 `.dat &Goto :Eof
Goto :__Color